/* MailTweak internal component - Copyright (C) 2007, 2010 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
EXPORTED_SYMBOLS = ["MailTweak_Mover"]
MailTweak_Mover = {
AM: Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager),PS: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),document: null,pref: null,init: function (doc) {
this.document = doc
this.pref = this.PS.getBranch("mail.accountmanager.")
var list = this.pref.getCharPref("accounts").split(",")
var tree = this.document.getElementById("account-tree-children")
var item = tree.firstChild, keep = {}
while (item) {
var k = item._account? item._account.key : "smtp"
keep[k] = tree.removeChild(item)
item = tree.firstChild}
for each (var a in list) if (keep[a]) tree.appendChild(keep[a])
tree.appendChild(keep.smtp)
this.document.documentElement.addEventListener("dialogaccept", function (event) {
var item = MailTweak_Mover.document.getElementById("account-tree-children").firstChild
var v0 = MailTweak_Mover.pref.getCharPref("accounts")
var list = v0.split(",")
var v1 = ""
while (item) {
if (item._account) {
var k = item._account.key
v1 += (v1? "," : "") + k
delete list[list.indexOf(k)]}
item = item.nextSibling}
for each (var k in list) if (k) v1 += "," + k
if (v1 != v0) {
MailTweak_Mover.pref.setCharPref("accounts", v1)
MailTweak_Mover.PS.savePrefFile(null)}}, false)},canMove: function (acct) {
if (!acct) return [false, false]
if (acct == this.AM.defaultAccount) return [false, false]
var item = this._item(acct)
if (!item) return [false, false]
var type = function (a) {
if (!a) return "smtp"
var t = a.incomingServer.type
return t == "none" || t == "nntp"? t : "mail"}
var prev = item.previousSibling, next = item.nextSibling, type0 = type(acct)
return [prev && type(prev._account) == type0 && prev._account != this.AM.defaultAccount,next && type(next._account) == type0]},_item: function (acct) {
var item = this.document.getElementById("account-tree-children").firstChild
while (item) {
if (item._account == acct) break
item = item.nextSibling}
return item},move: function (acct, up) {
var item = this._item(acct)
if (!item) return
var tgt = item[up? "previousSibling":"nextSibling"]
with (item.parentNode) {
if (up) insertBefore(item, tgt)
else insertBefore(tgt, item)}
var tree = this.document.getElementById("accounttree")
with (tree.view) {
var i = getIndexOfItem(item)
selection.select(i)}
tree.boxObject.ensureRowIsVisible(i)
tree.focus()},clean: function () {
var useful = {}
useful["mail.server.default"] = true
useful["mail.identity.default"] = true
var aa = this.AM.accounts, n = aa.Count()
for (var i = 0; i < n; ++i) {
var a = aa.QueryElementAt(i, Components.interfaces.nsIMsgAccount)
useful["mail.account." + a.key] = true
var s = a.incomingServer
useful["mail.server." + s.key] = true
var ids = a.identities, m = ids.Count()
for (var j = 0; j < m; ++j) {
var id = ids.QueryElementAt(j, Components.interfaces.nsIMsgIdentity)
useful["mail.identity." + id.key] = true}}
s = this.AM.FindServer("nobody", "smart mailboxes", "none")
useful["mail.server." + s.key] = true
a = this.AM.FindAccountForServer(s)
useful["mail.account." + a.key] = true
var pref = MailTweak_Mover.PS.getBranch("mail.account.")
var pp = pref.getChildList("", {})
for each (var p in pp) {
if (pref.prefHasUserValue(p)) {
var k = "mail.account." + p.replace(/\..*/g, "")
if (!useful[k]) useful[k] = false}}
var pref = MailTweak_Mover.PS.getBranch("mail.server.")
var pp = pref.getChildList("", {})
for each (var p in pp) {
if (pref.prefHasUserValue(p)) {
var k = "mail.server." + p.replace(/\..*/g, "")
if (!useful[k]) useful[k] = false}}
var pref = MailTweak_Mover.PS.getBranch("mail.identity.")
var pp = pref.getChildList("", {})
for each (var p in pp) {
if (pref.prefHasUserValue(p)) {
var k = "mail.identity." + p.replace(/\..*/g, "")
if (!useful[k]) useful[k] = false}}
var txt = ""
for (var k in useful) if (!useful[k]) txt += " " + k + "\n"
var tell = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService)
if (!txt) {
tell.alert(
MailTweak_Mover.document.defaultView,"Account Cleanup", "Nothing to do")
return}
var ok = tell.confirm(
MailTweak_Mover.document.defaultView,"Account Cleanup", "Found:\n" + txt + "\nRemove all these?")
if (!ok) return
for (var k in useful) if (!useful[k]) {
var pref = MailTweak_Mover.PS.getBranch(k)
pref.deleteBranch("")}
MailTweak_Mover.PS.savePrefFile(null)}}