/* MailTweak internal component - Copyright (C) 2007, 2010 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
tweaks = [
"accselect","accttools","addrlines","bccdefault","collect","columnlock","compact","configdata","cssselect","defer","deletion","dialogmenu","disconnect","dontsave","extoptions","filepick","focusfix","folderhide","foldericon","foldermenu","font","forcehtml","images","insertmenu","header","keepcopy","localhide","msgnumber","newacct","nosubject","offline","opento","password","prefcache","permapen","personal","replyground","searches","splitter","start","statusicon","statuslog","tagnumber","tagtools","treefont","wordcount"
]
APP = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime)
TB3 = (parseInt(APP.QueryInterface(Components.interfaces.nsIXULAppInfo).version.charAt(0)) > 2)
elem = function (id) {return document.getElementById(id)}
pref = {
__proto__: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak."),getUniCharPref: function (p) {
var s = this.getComplexValue(p, Components.interfaces.nsISupportsString)
return s.toString()},setUniCharPref: function (p, v) {
var s = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString)
s.data = v
this.setComplexValue(p, Components.interfaces.nsISupportsString, s)}}
accept = function () {
var m = false, a = false, c = false
if (elem("reload").checked)
for each (var t in tweaks) if (this[t].changed)
m = m || this[t].reloadMail,a = a || this[t].reloadAB,c = c || this[t].reloadComp
for each (var t in tweaks) this[t].save()
if (m || a || c) MailTweakService.reload(m, a, c)}
changes = function () {
var rl = false, ok = false
for each (var t in tweaks) {
var c = this[t].changed
if (c) rl = rl || this[t].reload
ok = ok || c}
with (elem("reload")) {
disabled = !ok || !rl
if (disabled) checked = false}
document.documentElement.getButton("accept").disabled = !ok}
enable = function (parent, ok) {
if (!parent.localName) return
switch (parent.localName) {
case "vbox":
case "hbox":
case "description":
case "grid":
case "columns":
case "column":
case "rows":
case "row":
break;
default: parent[ok? "removeAttribute":"setAttribute"]("disabled", "true")}
var e = parent.firstChild
while (e) enable(e, ok), e = e.nextSibling}
guide = function () {
openURL("http://mailtweak.mozdev.org/tweaks.html#" + currentPanel.id)}
listClick = function (event) {
var tgt = event.originalTarget
if (event.screenX
&& tgt.localName == "listitem"
&& event.screenX >= document.getAnonymousNodes(
document.getAnonymousNodes(tgt)[0])
[1].boxObject.screenX)
event.stopPropagation()
else setTimeout(listSelect, 0)}
listKey = function (event) {
if (event.charCode == 32) setTimeout(changes, 0)}
currentPanel = null
listSelect = function (event) {
var listitem = elem("tweak-list").selectedItem
var tweakid = listitem.id.replace(/urn:mailtweak:/, "")
var panel = elem(tweakid)
if (currentPanel) panelAccess(currentPanel, false)
panelAccess(panel, true)
currentPanel = panel
elem("item-caption").setAttribute("label", listitem.label)
elem("item-deck").selectedPanel = panel
enable(panel, listitem.checked)
this[tweakid].ui()
changes()
pref.setCharPref("_option", tweakid)}
panelAccess = function (node, ok) {
var c = node.firstChild
if (!c || !c.localName) return
while (c) {
if (ok) {
if (c.hasAttribute("keywas"))
c.setAttribute("accesskey", c.getAttribute("keywas"))}
else {
if (c.hasAttribute("accesskey"))
c.setAttribute("keywas", c.getAttribute("accesskey")), c.removeAttribute("accesskey")}
panelAccess(c, ok)
c = c.nextSibling}}
onload = function () {
var os = APP.OS.toUpperCase().substr(0, 3)
if (os != "WIN" && os != "OS2")
document.title = document.documentElement.getAttribute("titleprefs")
with (document.documentElement)
getButton("accept").disabled = true,setAttribute("wait-cursor", "true")
setTimeout(onloadbis, 0)}
onloadbis = function () {
document.loadOverlay("chrome://mailtweak/content/options-deck.xul", {observe: onloadter})}
onloadter = function () {
const RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService)
const RCU = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils)
var ds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource)
var seq = RCU.MakeSeq(ds, RDF.GetResource("urn:mailtweak:root"))
const label = RDF.GetResource("mailtweak#label")
var panel = elem("item-deck").firstChild
while (panel) {
if (!TB3 || panel.id != "focusfix") {
var res = RDF.GetResource("urn:mailtweak:" + panel.id)
ds.Assert(res, label, RDF.GetLiteral(panel.getAttribute("label")), true)
seq.AppendElement(res)
panelAccess(panel, false)}
panel = panel.nextSibling}
var list = elem("tweak-list")
with (list) database.AddDataSource(ds), builder.rebuild()
try {Components.classes["@mozilla.org/messenger/tagservice;1"].getService(Components.interfaces.nsIMsgTagService)}
catch (ex) {
with (elem("tagnumber")) checked = false, disabled = true}
for each (var t in tweaks) {
try {window[t].init()} catch (ex) {dump("MailTweak " + ex + "\n")}}
list.addEventListener("mousedown", function (event) {listClick(event)}, true)
var opt = pref.getCharPref("_option")
if (opt) {
var item = document.getElementById("urn:mailtweak:" + opt)
list.ensureElementIsVisible(item)
list.selectItem(item)}
else list.selectedIndex = 0
list.focus()
addEventListener("keypress", function (event) {pageKey(event)}, false)
document.documentElement.removeAttribute("wait-cursor")}
pageKey = function (event) {
if (event.keyCode != event.DOM_VK_PAGE_UP
&& event.keyCode != event.DOM_VK_PAGE_DOWN) return
var list = elem("tweak-list")
if (event.target == list) return
var i = list.selectedIndex
+ (event.keyCode == event.DOM_VK_PAGE_UP? -1:1)
if (i < 0 || i > list.getRowCount()) return
list.selectedIndex = i
list.ensureIndexIsVisible(i)
listSelect()}
scrollKey = function (event) {
var bar = event.target
var now = Number(bar.getAttribute("curpos"))
switch (event.keyCode) {
case event.DOM_VK_LEFT:
case event.DOM_VK_DOWN:
if (now > 0) bar.setAttribute("curpos", now - Number(bar.getAttribute("increment")))
break;
case event.DOM_VK_RIGHT:
case event.DOM_VK_UP:
if (now < Number(bar.getAttribute("maxpos")))
bar.setAttribute("curpos", now + Number(bar.getAttribute("increment")))
break;
case event.DOM_VK_HOME:
bar.setAttribute("curpos", 0)
break;
case event.DOM_VK_END:
bar.setAttribute("curpos", bar.getAttribute("maxpos"))
break;}
changes()}
tabSelect = function (panels) {
var p = panels.childNodes, i = panels.selectedIndex
panelAccess(p[1 - i], false)
panelAccess(p[i], true)}
Tweak = {
id: "",reloadMail: false,reloadAB: false,reloadComp: false,get active () {return this._checkbox.checked},get changed () {return this._checkbox.checked != this._waschecked},get reload () {return this.reloadMail || this.reloadAB || this.reloadComp},init: function () {
this._checkbox = elem("urn:mailtweak:" + this.id)
var ok = pref.getBoolPref(this.id)
this._checkbox.checked = ok
this._waschecked = ok},save: function () {pref.setBoolPref(this.id, this._checkbox.checked)},ui: function () {}}
accselect = {
__proto__: Tweak,id: "accselect"}
accttools = {
__proto__: Tweak,id: "accttools",init: function () {
Tweak.init.call(this)
this._checkbox.disabled = !TB3}}
addrlines = {
__proto__: Tweak,id: "addrlines",reloadComp: true,get changed () {
var r = this._checkbox.checked != this._waschecked
|| this._lines.value != pref.getIntPref("addrlines.lines")
return r},init: function () {
Tweak.init.call(this)
this._lines = elem("addrlines-lines")
this._lines.value = pref.getIntPref("addrlines.lines")},save: function () {
Tweak.save.call(this)
pref.setIntPref("addrlines.lines", this._lines.value)}}
bccdefault = {
__proto__: Tweak,id: "bccdefault",reloadComp: true}
collect = {
__proto__: Tweak,id: "collect",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._bcc.checked != pref.getBoolPref("collect.bcc")
|| this._retry.checked != pref.getBoolPref("collect.retry")},init: function () {
Tweak.init.call(this)
this._bcc = elem("collect-bcc")
this._retry = elem("collect-retry")
this._bcc.checked = pref.getBoolPref("collect.bcc")
this._retry.checked = pref.getBoolPref("collect.retry")},save: function () {
Tweak.save.call(this)
pref.setBoolPref("collect.bcc", this._bcc.checked)
pref.setBoolPref("collect.retry", this._retry.checked)}}
columnlock = {
__proto__: Tweak,id: "columnlock",reloadMail: true,reloadAB: true}
compact = {
__proto__: Tweak,id: "compact",reloadMail: true}
configdata = {
__proto__: Tweak,id: "configdata",reloadMail: true}
cssselect = {
__proto__: Tweak,id: "cssselect",reloadMail: true}
defer = {
__proto__: Tweak,id: "defer",reloadMail: true,reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._tag.value != pref.getCharPref("defer.tag")},init: function () {
Tweak.init.call(this)
this._tag = elem("defer-tag")
var tt = Components.classes["@mozilla.org/messenger/tagservice;1"].getService(Components.interfaces.nsIMsgTagService).getAllTags({})
var pop = this._tag.firstChild
for each (var t in tt) {
with (pop.appendChild(document.createElement("menuitem")))
setAttribute("label", t.tag),setAttribute("value", t.key),setAttribute("color", t.color),style.color = t.color}
this._tag.value = pref.getCharPref("defer.tag")},save: function () {
Tweak.save.call(this)
pref.setCharPref("defer.tag", this._tag.value || "")},tag: function (elem) {
elem.style.color = elem.selectedItem.getAttribute("color")
changes()}}
deletion = {
__proto__: Tweak,id: "deletion",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._radio.value != pref.getIntPref("deletion.mode")},init: function () {
Tweak.init.call(this)
this._radio = elem("deletion-radio")
this._radio.value = pref.getIntPref("deletion.mode")},save: function () {
Tweak.save.call(this)
pref.setIntPref("deletion.mode", this._radio.value || 0)}}
dialogmenu = {
__proto__: Tweak,id: "dialogmenu",reloadMail: true}
disconnect = {
__proto__: Tweak,id: "disconnect",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._delay.value != pref.getIntPref("disconnect.delay")
|| this._script.value != pref.getCharPref("disconnect.script")
|| this._offline.checked != pref.getBoolPref("disconnect.offline")},init: function () {
Tweak.init.call(this)
this._delay = elem("disconnect-delay")
this._script = elem("disconnect-script")
this._offline = elem("disconnect-offline")
this._delay.value = pref.getIntPref("disconnect.delay")
this._script.value = pref.getCharPref("disconnect.script")
this._offline.checked = pref.getBoolPref("disconnect.offline")},save: function () {
Tweak.save.call(this)
pref.setIntPref("disconnect.delay", this._delay.value || 0)
pref.setCharPref("disconnect.script", this._script.value)
pref.setBoolPref("disconnect.offline", this._offline.checked)}}
dontsave = {
__proto__: Tweak,id: "dontsave",reloadComp: true}
extoptions = {
__proto__: Tweak,id: "extoptions"}
filepick = {
__proto__: Tweak,id: "filepick",reloadMail: true,reloadComp: true}
focusfix = {
__proto__: Tweak,id: "focusfix",reloadComp: true,init: function () {
if (TB3) {
this._checkbox = {checked: false}
this._waschecked = false}
else Tweak.init.call(this)}}
folderhide = {
__proto__: Tweak,id: "folderhide",reloadMail: true}
foldericon = {
__proto__: Tweak,id: "foldericon",reloadMail: true}
foldermenu = {
__proto__: Tweak,id: "foldermenu",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._favorite.checked != pref.getBoolPref("foldermenu.favorite")
|| this._recent.checked != pref.getBoolPref("foldermenu.recent")
|| (TB3 && this._max.value != pref.getIntPref("foldermenu.maxrecent"))},init: function () {
Tweak.init.call(this)
this._favorite = elem("foldermenu-favorite")
this._recent = elem("foldermenu-recent")
this._max = elem("foldermenu-max")
this._favorite.checked = pref.getBoolPref("foldermenu.favorite")
this._recent.checked = pref.getBoolPref("foldermenu.recent")
this._max.value = pref.getIntPref("foldermenu.maxrecent")
elem("foldermenu-maxrecent").hidden = !TB3},save: function () {
Tweak.save.call(this)
pref.setBoolPref("foldermenu.favorite", this._favorite.checked)
pref.setBoolPref("foldermenu.recent", this._recent.checked)
if (TB3) pref.setIntPref("foldermenu.maxrecent", this._max.value)}}
font = {
__proto__: Tweak,id: "font",reloadComp: true,FE: Components.classes["@mozilla.org/gfx/fontenumerator;1"].getService(Components.interfaces.nsIFontEnumerator),was: {
html_font: "",html_size: 0,plain_font: "",plain_size: 0},get changed () {
return this._checkbox.checked != this._waschecked
|| this._list_html.value != this.was.html_font
|| this._list_plain.value != this.was.plain_font
|| this.pixels(this._size_html.value) != this.was.html_size
|| this.pixels(this._size_plain.value) != this.was.plain_size
|| this._unit_html.value != (pref.getBoolPref("font.px")? "px" : "pt")},init: function () {
Tweak.init.call(this)
this._list_html = elem("font-list-html")
this._list_plain = elem("font-list-plain")
this._size_html = elem("font-size-html")
this._size_plain = elem("font-size-plain")
this._unit_html = elem("font-unit-html")
this._unit_plain = elem("font-unit-plain")
this._sample_html = elem("font-sample-html")
this._sample_plain = elem("font-sample-plain")
var px = window.pref.getBoolPref("font.px")
this._unit_html.selectedIndex = px? 0 : 1
this._unit_plain.selectedIndex = px? 0 : 1
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch)
var locale = pref.getCharPref("general.useragent.locale").toLowerCase()
var groups = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("resource://gre/res/langGroups.properties")
this._group = ""
try {this._group = groups.GetStringFromName(locale)} catch (ex) {}
if (!this._group) try {this._group = groups.GetStringFromName(locale.replace(/-.*$/, ""))}
catch (ex) {this._group = "x-western"}
var def = pref.getCharPref("font.default." + this._group)
var v = pref.getCharPref("font.name." + def + "." + this._group)
with (this._list_html) setAttribute("label", v), setAttribute("value", v)
this.was.html_font = v
v = pref.getCharPref("font.name.monospace." + this._group)
with (this._list_plain) setAttribute("label", v), setAttribute("value", v)
this.was.plain_font = v
var point = document.createElement("box")
point.style.width = "1pt"
this.dpt = parseFloat(getComputedStyle(point, null).width)
v = pref.getIntPref("font.size.variable." + this._group)
this.was.html_size = v
this._sample_html.style.fontSize = v + "px"
this._size_html.value = px? v : Math.round(v / this.dpt)
v = pref.getIntPref("font.size.fixed." + this._group)
this.was.plain_size = v
this._sample_plain.style.fontSize = v + "px"
this._size_plain.value = px? v : Math.round(v / this.dpt)},listFonts: function (popup, mono) {
if (popup.firstChild) return
var v = popup.parentNode.getAttribute("value")
var ff = this.FE.EnumerateFonts(this._group, mono? "monospace" : "", {})
ff.sort(function (a, b) {
var c = a.toLowerCase(), d = b.toLowerCase()
return c == d? 0 : c > d? 1 : -1})
var nit = ""
for (var i = 0; i < ff.length; ++i) {
var f = ff[i]
var c = f.charAt(0).toUpperCase()
if (c != nit) {
with (popup.appendChild(document.createElement("menuseparator")))
with (appendChild(document.createElement("label"))) value = c
nit = c}
with (popup.appendChild(document.createElement("menuitem"))) {
setAttribute("label", f)
setAttribute("value", f)
if (f == v) setAttribute("selected", "true")}}},pixels: function (n) {
return this._unit_html.value == "px"? n : Math.round(n * this.dpt)},sample: function (elem, nochange) {
var sfx = elem.id.indexOf("html") > 0? "html":"plain"
if (elem.id.indexOf("list") > 0) {
var v = document.getElementById("font-list-" + sfx).value
document.getElementById("font-sample-" + sfx).style.fontFamily = v}
else {
var px = document.getElementById("font-unit-" + sfx).value == "px"
var size = document.getElementById("font-size-" + sfx)
var v = size.value
if (elem.id.indexOf("unit") > 0) {
var other = document.getElementById("font-unit-" + (elem.id.indexOf("html") > 0? "plain":"html"))
other.value = px? "px" : "pt"
if (!nochange) this.sample(other, true)
v = Math.round(px? v * this.dpt : v / this.dpt)
size.value = v}
document.getElementById("font-sample-" + sfx).style.fontSize = v + (px? "px":"pt")}
if (!nochange) changes()},save: function () {
Tweak.save.call(this)
window.pref.setBoolPref("font.px", this._unit_html.value != "pt")
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch)
var v = this._list_html.value
var ff = this.FE.EnumerateFonts("", "serif", {})
var serif = ff.indexOf(v) >= 0
if (serif) {
ff = this.FE.EnumerateFonts("", "sans-serif", {})
if (ff.indexOf(v) >= 0) serif = false}
var cc = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("resource://gre/res/charsetData.properties").getSimpleEnumeration()
var cs = []
while (cc.hasMoreElements()) {
var c = cc.getNext().QueryInterface(Components.interfaces.nsIPropertyElement)
if (c.key.indexOf(".LangGroup") > 0 && c.value == this._group)
cs.push(c.key.match(/^[^.]*/).toString().toUpperCase())}
var sdc = pref.getCharPref("mailnews.send_default_charset")
if (cs.indexOf(sdc) < 0) {
for (var i = 0; i < cs.length; ++i) {
sdc = cs[i]
if (sdc.indexOf("iso") == 0) break}
pref.setCharPref("mailnews.send_default_charset", sdc)}
pref.setCharPref("mailnews.view_default_charset", sdc)
pref.setCharPref("font.language.group", this._group)
pref.setCharPref("font.default." + this._group, serif? "serif" : "sans-serif")
pref.setCharPref("font.name." + (serif? "serif" : "sans-serif") + "." + this._group, v)
pref.setCharPref("font.name.monospace." + this._group, this._list_plain.value)
pref.setIntPref("font.size.variable." + this._group, this.pixels(this._size_html.value))
pref.setIntPref("font.size.fixed." + this._group, this.pixels(this._size_plain.value))
pref.setIntPref("font.minimum-size." + this._group, Math.floor(this._size_html.value * .75))
pref.setBoolPref("mail.fixed_width_messages", true)
pref.setIntPref("browser.display.use_document_fonts", 1)
pref.setBoolPref("mailnews.force_charset_override", false)
pref.setBoolPref("mailnews.reply_in_default_charset", false)
pref.setIntPref("mail.default_html_action", 3)
pref.setCharPref("msgcompose.font_face", "")
pref.setCharPref("msgcompose.font_size", "medium")},ui: function () {
tabSelect(elem("font-panels"))
this.sample({id: "font-list-html"}, true)
this.sample({id: "font-list-plain"}, true)
this.sample({id: "font-size-html"}, true)
this.sample({id: "font-size-plain"})}}
forcehtml = {
__proto__: Tweak,id: "forcehtml",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._both.checked != pref.getBoolPref("forcehtml.both")},init: function () {
Tweak.init.call(this)
this._both = elem("forcehtml-both")
this._both.checked = pref.getBoolPref("forcehtml.both")},save: function () {
Tweak.save.call(this)
pref.setBoolPref("forcehtml.both", this._both.checked)}}
header = {
__proto__: Tweak,id: "header",reloadMail: true}
images = {
__proto__: Tweak,id: "images",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._attach.checked != pref.getBoolPref("images.attach")
|| this._alttext.checked != pref.getBoolPref("images.alttext")
|| this._text.value != pref.getUniCharPref("images.text")},init: function () {
Tweak.init.call(this)
this._attach = elem("images-attach")
this._alttext = elem("images-alttext")
this._text = elem("images-text")
this._attach.checked = pref.getBoolPref("images.attach")
this._alttext.checked = pref.getBoolPref("images.alttext")
with (this._text)
value = pref.getUniCharPref("images.text"), setAttribute("was", value)},save: function () {
Tweak.save.call(this)
pref.setBoolPref("images.attach", this._attach.checked)
pref.setBoolPref("images.alttext", this._alttext.checked)
pref.setUniCharPref("images.text", this._text.value)},ui: function () {
var ok = this._alttext.checked
with (this._text) {
disabled = !ok
if (ok) value = getAttribute("was") || getAttribute("fallback")
else setAttribute("was", value), value = ""}}}
insertmenu = {
__proto__: Tweak,id: "insertmenu",reloadComp: true}
keepcopy = {
__proto__: Tweak,id: "keepcopy",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._noprompt.checked != pref.getBoolPref("keepcopy.noprompt")},init: function () {
Tweak.init.call(this)
this._noprompt = elem("keepcopy-noprompt")
this._noprompt.checked = pref.getBoolPref("keepcopy.noprompt")},save: function () {
Tweak.save.call(this)
pref.setBoolPref("keepcopy.noprompt", this._noprompt.checked)}}
localhide = {
__proto__: Tweak,id: "localhide",reloadMail: true}
msgnumber = {
__proto__: Tweak,id: "msgnumber",reloadMail: true}
newacct = {
__proto__: Tweak,id: "newacct",reloadMail: true,init: function () {
Tweak.init.call(this)
this._checkbox.disabled = !TB3}}
nosubject = {
__proto__: Tweak,id: "nosubject",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._text.value != pref.getUniCharPref("nosubject.text")},init: function () {
Tweak.init.call(this)
this._text = elem("nosubject-text")
with (this._text) {
if (pref.prefHasUserValue("nosubject.text"))
value = pref.getUniCharPref("nosubject.text")
else pref.setUniCharPref("nosubject.text", value)
setAttribute("was", value)}},save: function () {
Tweak.save.call(this)
pref.setUniCharPref("nosubject.text", this._text.value)}}
offline = {
__proto__: Tweak,id: "offline",reloadComp: true,get changed () {
return this._checkbox.checked != this._waschecked
|| this._forget.checked != pref.getBoolPref("offline.forget")},init: function () {
Tweak.init.call(this)
this._forget = elem("offline-forget")
this._forget.checked = pref.getBoolPref("offline.forget")},save: function () {
Tweak.save.call(this)
pref.setBoolPref("offline.forget", this._forget.checked)}}
opento = {
__proto__: Tweak,id: "opento",reloadMail: true}
password = {
__proto__: Tweak,id: "password",get changed () {
this._checkbox.setAttribute("disabled", "true")
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("password-hide").checked != pref.getBoolPref("password.hide")
|| elem("password-set").checked != pref.getBoolPref("password.set")))},init: function () {
Tweak.init.call(this)
this._set = elem("password-set")
this._hide = elem("password-hide")
this._set.checked = pref.getBoolPref("password.set")
this._hide.checked = pref.getBoolPref("password.hide")},save: function () {
if (!this._set.checked && !this._hide.checked) this._checkbox.checked = false
Tweak.save.call(this)
pref.setBoolPref("password.set", this._set.checked)
pref.setBoolPref("password.hide", this._hide.checked)}}
permapen = {
__proto__: Tweak,id: "permapen",reloadComp: true,_platform: null,get changed () {return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("permapen-face").value != pref.getCharPref("permapen.face")
|| elem("permapen-size").value != pref.getIntPref("permapen.size")
|| elem("permapen-color").color != pref.getCharPref("permapen.color")
|| elem("permapen-ground").color != pref.getCharPref("permapen.ground")
|| elem("permapen-bold").checked != pref.getBoolPref("permapen.bold")
|| elem("permapen-italic").checked != pref.getBoolPref("permapen.italic")
|| elem("permapen-underline").checked != pref.getBoolPref("permapen.underline")
|| elem("permapen-key").getAttribute("keyspec") != pref.getCharPref("permapen.key")))},init: function () {
Tweak.init.call(this)
var flist = elem("permapen-face")
try {
var ff = Components.classes["@mozilla.org/gfx/fontenumerator;1"].getService(Components.interfaces.nsIFontEnumerator).EnumerateAllFonts({})
for each (var f in ff) if (f) flist.appendItem(f, f)} catch (ex) {}
flist.value = pref.getCharPref("permapen.face")
elem("permapen-size").value = pref.getIntPref("permapen.size")
elem("permapen-color").color = pref.getCharPref("permapen.color")
elem("permapen-ground").color = pref.getCharPref("permapen.ground")
elem("permapen-bold").checked = pref.getBoolPref("permapen.bold")
elem("permapen-italic").checked = pref.getBoolPref("permapen.italic")
elem("permapen-underline").checked = pref.getBoolPref("permapen.underline")
elem("permapen-key").setAttribute("keyspec", pref.getCharPref("permapen.key"))
this._platform = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://global-platform/locale/platformKeys.properties")
this.keyDisplay()},key: function (event) {
if (event.keyCode == 9) return
var k = []
if (event.ctrlKey) k.push("control")
if (event.altKey) k.push("alt")
if (event.metaKey) k.push("meta")
if (event.shiftKey) k.push("shift")
var ok = false
if (event.charCode) {
ok = k.length > 0
if (ok) k.push(String.fromCharCode(event.charCode).toUpperCase())}
else {
for (e in event) {
if (e.indexOf("DOM_") == 0 && event[e] == event.keyCode) {
k.push(e.substr(4))
ok = true
break}}}
if (ok) {
event.target.setAttribute("keyspec", k.join(" "))
this.keyDisplay()
changes()}
event.preventDefault()},keyDisplay: function () {
var textbox = elem("permapen-key")
var k = textbox.getAttribute("keyspec").split(" ")
var t = [], key = k.pop().replace(/VK_/, "")
for each (var e in k)
t.push(this._platform.GetStringFromName("VK_" + e.toUpperCase()))
t.push(key)
textbox.value = t.join(this._platform.GetStringFromName("MODIFIER_SEPARATOR"))},save: function () {
Tweak.save.call(this)
pref.setCharPref("permapen.key", elem("permapen-key").getAttribute("keyspec"))
pref.setCharPref("permapen.face", elem("permapen-face").value)
pref.setIntPref("permapen.size", elem("permapen-size").value)
pref.setCharPref("permapen.color", elem("permapen-color").color)
pref.setCharPref("permapen.ground", elem("permapen-ground").color)
pref.setBoolPref("permapen.bold", elem("permapen-bold").checked)
pref.setBoolPref("permapen.italic", elem("permapen-italic").checked)
pref.setBoolPref("permapen.underline", elem("permapen-underline").checked)}}
personal = {
__proto__: Tweak,id: "personal",reloadMail: true,reloadAB: true,reloadComp: true,get changed () {return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("personal-marker").value != pref.getCharPref("personal.marker")
|| elem("personal-uniqueid").checked != pref.getBoolPref("personal.uniqueid")))},init: function () {
Tweak.init.call(this)
this._marker = elem("personal-marker")
this._marker.value = pref.getCharPref("personal.marker")
this._example = elem("personal-example").firstChild
this.showExample(true)
this._uniqueid = elem("personal-uniqueid")
this._uniqueid.checked = pref.getBoolPref("personal.uniqueid")},showExample: function (normalize) {
var m = this._marker.value.replace(/\s/g, "")
if (m == "") m = "%%"
if (normalize) this._marker.value = m
this._example.nodeValue = m + "firstName" + m},save: function () {
Tweak.save.call(this)
pref.setCharPref("personal.marker", this._marker.value)
pref.setBoolPref("personal.uniqueid", this._uniqueid.checked)}}
personal = {
__proto__: Tweak,id: "personal",reloadMail: true,reloadAB: true,reloadComp: true,get changed () {return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("personal-marker").value != pref.getCharPref("personal.marker")
|| elem("personal-uniqueid").checked != pref.getBoolPref("personal.uniqueid")))},init: function () {
Tweak.init.call(this)
this._marker = elem("personal-marker")
this._marker.value = pref.getCharPref("personal.marker")
this._example = elem("personal-example").firstChild
this.showExample(true)
this._uniqueid = elem("personal-uniqueid")
this._uniqueid.checked = pref.getBoolPref("personal.uniqueid")},showExample: function (normalize) {
var m = this._marker.value.replace(/\s/g, "")
if (m == "") m = "%%"
if (normalize) this._marker.value = m
this._example.nodeValue = m + "firstName" + m},save: function () {
Tweak.save.call(this)
pref.setCharPref("personal.marker", this._marker.value)
pref.setBoolPref("personal.uniqueid", this._uniqueid.checked)}}
prefcache = {
__proto__: Tweak,id: "prefcache"}
replyground = {
__proto__: Tweak,id: "replyground",reloadComp: true,reloadMail: true}
searches = {
__proto__: Tweak,id: "searches",reloadMail: true,reloadAB: true}
statusicon = {
__proto__: Tweak,id: "statusicon"}
start = {
__proto__: Tweak,id: "start",get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("start-date").value != pref.getIntPref("start.date")
|| elem("start-ordinal").checked != pref.getBoolPref("start.ordinal")
|| elem("start-week").checked != pref.getBoolPref("start.week")
|| elem("start-clock").value != pref.getIntPref("start.clock")))},init: function () {
Tweak.init.call(this)
elem("start-date").value = pref.getIntPref("start.date")
elem("start-ordinal").checked = pref.getBoolPref("start.ordinal")
elem("start-week").checked = pref.getBoolPref("start.week")
var c = elem("start-clock")
c.value = pref.getIntPref("start.clock")
if (!Boolean(window.SVGDocument)) {
if (c.value == "3") pref.setIntPref("start.clock", 0), c.value = "0"
c.firstChild.hidden = true}},save: function () {
Tweak.save.call(this)
pref.setIntPref("start.date", elem("start-date").value)
pref.setBoolPref("start.ordinal", elem("start-ordinal").checked)
pref.setBoolPref("start.week", elem("start-week").checked)
pref.setIntPref("start.clock", elem("start-clock").value)},ui: function () {
var clock = elem("start-object")
var d = Number(elem("start-date").value)
var o = elem("start-ordinal")
o.disabled = (d == 3)
clock.dateordinal = o.checked
var w = elem("start-week")
clock.dateweek = w.checked
clock.datelong = (d < 3)
clock.dateformat = d == 3? 0 : d
var c = Number(elem("start-clock").value)
clock.timeformat = c == 3? 0 : c
clock.notify(null)
elem("start-datesample").value = elem("today-date").value
+ (elem("start-week").checked? " - " + elem("today-week").value : "")
var s = elem("start-timesample")
s.hidden = (c == 3)
s.previousSibling.hidden = (c < 3)
if (c < 3) s.value = elem("clock-hour").value + ":"
+ elem("clock-minute").value + " " + elem("clock-ampm").value}}
splitter = {
__proto__: Tweak,id: "splitter",reloadMail: true,reloadAB: true}
statuslog = {
__proto__: Tweak,id: "statuslog",reloadMail: true,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
elem("statuslog-display").value != pref.getIntPref("statuslog.display")
|| elem("statuslog-type").selectedIndex != pref.getIntPref("statuslog.type")
|| elem("statuslog-limit").value != pref.getIntPref("statuslog.limit")))},init: function () {
Tweak.init.call(this)
elem("statuslog-display").value = pref.getIntPref("statuslog.display")
elem("statuslog-type").selectedIndex = pref.getIntPref("statuslog.type")
elem("statuslog-limit").value = pref.getIntPref("statuslog.limit")},save: function () {
Tweak.save.call(this)
pref.setIntPref("statuslog.display", elem("statuslog-display").value)
pref.setIntPref("statuslog.type", elem("statuslog-type").selectedIndex)
pref.setIntPref("statuslog.limit", elem("statuslog-limit").value)},ui: function () {
this._radio = elem("statuslog-type")
var n = elem("statuslog-limit")
switch (this._radio.selectedItem.value) {
case "0": 
n.setAttribute("min", "10")
n.setAttribute("max", "1000")
n.setAttribute("log", "single")
n.setAttribute("step", "1.33")
break
case "1": 
n.setAttribute("min", "5")
n.setAttribute("max", "60")
n.removeAttribute("log")
n.setAttribute("step", "15")
break
case "2": 
n.setAttribute("min", "1")
n.setAttribute("max", "24")
n.setAttribute("log", "whole")
n.setAttribute("step", "2")
break}}}
tagnumber = {
__proto__: Tweak,id: "tagnumber",reloadMail: true,_wait: null,_key: null,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked
&& elem("tagnumber-delay").getAttribute("curpos") != this._curposwas)},get delay () {
return 200 + Number(elem("tagnumber-delay").getAttribute("curpos")) * 100},init: function () {
Tweak.init.call(this)
this._curposwas = (pref.getIntPref("tagnumber.delay") - 200) / 100
with (elem("tagnumber-delay")) {
setAttribute("curpos", this._curposwas)
addEventListener("DOMAttrModified",function (event) {
if (event.attrName != "curpos" || event.eventPhase != 2) return
changes()},true)}},keyAction: function () {
this._wait = null
elem("tagnumber-test").value = this._key
this._key = 0},test: function (event) {
elem("tagnumber-test").value = ""
event.preventDefault()
if (!event.charCode || event.charCode < event.DOM_VK_0 || event.charCode > event.DOM_VK_9)
return
var k = event.charCode - event.DOM_VK_0, n = 19
if (this._wait) {
clearTimeout(this._wait)
this._wait = null
this._key = this._key * 10 + k
var go = this._key * 10 > n}
else {
this._key = k
var go = k == 0 || k * 10 > n}
if (go) this.keyAction()
else this._wait = setTimeout("tagnumber.keyAction()", this.delay)},save: function () {
Tweak.save.call(this)
pref.setIntPref("tagnumber.delay", this.delay)}}
tagtools = {
__proto__: Tweak,id: "tagtools"}
treefont = {
__proto__: Tweak,id: "treefont",reloadMail: true,reloadAB: true,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked
&& elem("treefont-size").getAttribute("curpos") != this._curposwas)},init: function () {
Tweak.init.call(this)
var size = pref.getIntPref("treefont.size")
if (size == 0) size = parseInt(document.defaultView.getComputedStyle(elem("treefont-sample"), "").fontSize)
elem("treefont-inbox").style.fontSize = String(size) + "px"
this._curposwas = size - 6
with (elem("treefont-size")) {
setAttribute("curpos", size - 6)
addEventListener("DOMAttrModified",function (event) {
if (event.attrName != "curpos" || event.eventPhase != 2) return
elem("treefont-inbox").style.fontSize = String(Number(event.newValue) + 6) + "px"
changes()},true)}},save: function () {
Tweak.save.call(this)
pref.setIntPref("treefont.size",Number(elem("treefont-size").getAttribute("curpos")) + 6)}}
wordcount = {
__proto__: Tweak,id: "wordcount",reloadComp: true}