/* MailTweak internal component - Copyright (C) 2007, 2010 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://mailtweak.mozdev.org/ */
EXPORTED_SYMBOLS = ["MailTweak_DeferPreset"]
MailTweak_DeferPreset = function (spec, now) {
this.now = now || new Date
this.spec = spec}
MailTweak_DeferPreset.default = null
MailTweak_DeferPreset.prototype = {
now: null,spec: "",get when () {
if (!this.spec) return this.now
with (this.now)
var when = new Date(getFullYear(), getMonth(), getDate(), getHours(), getMinutes(), 0, 0)
var ee = this.spec.trim().replace(/\s+/g, " ").split(" ")
if (ee[0].indexOf(":") < 0) when.setHours(0), when.setMinutes(0)
for each (var e in ee) when = this._element(when, e)
return when},_element: function (when, elem) {
if (elem.indexOf(":") >= 0) return this._timeElement(when, elem)
else if (elem.indexOf("/") >= 0) return this._dateElement(when, elem)
else return this._weekdayElement(when, elem)},_timeElement: function (when, elem) {
var ee = elem.split(":")
if (ee.length != 2) return null
when = this._minuteValue(when, ee[1])
when = this._hourValue(when, ee[0])
return when},_dateElement: function (when, elem) {
var ee = elem.split("/")
if (ee.length != 3) return null
when = this._dateValue(when, ee[2])
when = this._monthValue(when, ee[1])
when = this._yearValue(when, ee[0])
return when},_weekdayElement: function (when, elem) {
when = this._weekdayValue(when, elem)
return when},_minuteValue: function (when, v) {
var n
switch (v.charAt(0)) {
case "[":
v = v.replace(/[\[\]]/g, "").split(",")
var a = [this._minuteValue(when, n) for each (n in v)]
var w = a[0]
for each (d in a) if (d < w) w = d
return w
break
case "=":
return when
break
case "+":
n = when.getMinutes() + parseInt(v.substr(1))
break
case "-":
n = when.getMinutes() - parseInt(v.substr(1))
break
default:
n = parseInt(v)}
var d = new Date(
when.getFullYear(), when.getMonth(), when.getDate(), when.getHours(), n, 0, 0)
while (d < this.now) d = new Date(
d.getFullYear(), d.getMonth(), d.getDate(), d.getHours() + 1, d.getMinutes(), 0, 0)
return d},_hourValue: function (when, v) {
var n
switch (v.charAt(0)) {
case "[":
v = v.replace(/[\[\]]/g, "").split(",")
var a = [this._hourValue(when, n) for each (n in v)]
var w = a[0]
for each (d in a) if (d < w) w = d
return w
break
case "=":
return when
break
case "+":
n = when.getHours() + parseInt(v.substr(1))
break
case "-":
n = when.getHours() - parseInt(v.substr(1))
break
default:
n = parseInt(v)}
var d = new Date(
when.getFullYear(), when.getMonth(), when.getDate(), n, when.getMinutes(), 0, 0)
while (d < this.now) d = new Date(
d.getFullYear(), d.getMonth(), d.getDate() + 1, d.getHours(), d.getMinutes(), 0, 0)
return d},_dateValue: function (when, v) {
var n
switch (v.charAt(0)) {
case "[":
v = v.replace(/[\[\]]/g, "").split(",")
var a = [this._dateValue(when, n) for each (n in v)]
var w = a[0]
for each (d in a) if (d < w) w = d
return w
break
case "=":
return when
break
case "+":
n = when.getDate() + parseInt(v.substr(1))
break
case "-":
n = when.getDate() - parseInt(v.substr(1))
break
default:
n = parseInt(v)}
var d = new Date(when.getFullYear(), when.getMonth(), n, when.getHours(), when.getMinutes(), 0, 0)
while (d < this.now) d = new Date(
d.getFullYear(), d.getMonth() + 1, d.getDate(), d.getHours(), d.getMinutes(), 0, 0)
return d},_monthValue: function (when, v) {
var n
switch (v.charAt(0)) {
case "[":
v = v.replace(/[\[\]]/g, "").split(",")
var a = [this._monthValue(when, n) for each (n in v)]
var w = a[0]
for each (d in a) if (d < w) w = d
return w
break
case "=":
return when
break
case "+":
n = when.getMonth() + parseInt(v.substr(1))
break
case "-":
n = when.getMonth() - parseInt(v.substr(1))
break
default:
n = parseInt(v) - 1}
var d = new Date(when.getFullYear(), n, when.getDate(), when.getHours(), when.getMinutes(), 0, 0)
while (d < this.now) d = new Date(
d.getFullYear() + 1, d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), 0, 0)
return d},_yearValue: function (when, v) {
var n
switch (v.charAt(0)) {
case "[":
v = v.replace(/[\[\]]/g, "").split(",")
var a = [this._yearValue(when, n) for each (n in v)]
var w = a[0]
for each (d in a) if (d < w) w = d
return w
break
case "=":
return when
break
case "+":
n = when.getFullYear() + parseInt(v.substr(1))
break
case "-":
n = when.getFullYear() - parseInt(v.substr(1))
break
default:
n = parseInt(v)}
var d = new Date(n, when.getMonth(), when.getDate(), when.getHours(), when.getMinutes(), 0, 0)
while (d < this.now) d = new Date(
d.getFullYear() + 1, d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), 0, 0)
return d},_weekdayValue: function (when, v) {
var n
switch (v.charAt(0)) {
case "[":
v = v.replace(/[\[\]]/g, "").split(",")
var a = [this._weekdayValue(when, n) for each (n in v)]
var w = a[0]
for each (d in a) if (d < w) w = d
return w
break
case "=":
return when
break
case "+":
case "-":
return this._dateValue(when, v)
break}
var x = when.getDate() - when.getDay() + Number(v)
while (x <= 0) x += 7
d = new Date(when.getFullYear(), when.getMonth(), x, when.getHours(), when.getMinutes(), 0)
while (d < this.now) d = new Date(d.getFullYear(), d.getMonth(), d.getDate() + 7, 0, 0, 0, 0)
return d},toString: function () "[object MailTweak_DeferPreset]"}
